/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/

#include <qfiledialog.h>

void XplodeExport::init()
{
    textName->setSelection(9, 3);
    setFocusProxy(textName);
}

void XplodeExport::changeDir()
{
    QString initialDir, target;
    // Set initial directory
    if (!textDirectory->text().startsWith("<")) initialDir = textDirectory->text();
    target = QFileDialog::getExistingDirectory (initialDir, this, "Xplode - Select Directory");
    // If the user selects a directory
    if (target != "") textDirectory->setText(target);
}


void XplodeExport::changeSuffix()
{
    QString fileName = textName->text();
    QString fileSuffix;
    // Get the file name suffix
    int index = fileName.findRev(".");
    if (index == -1)
	fileSuffix = "";
    else
	fileSuffix = fileName.mid(index + 1);
    // Check the suffix and fix it
    if (radioVrml->isChecked())
    {
	// No suffix: add it
	if (fileSuffix == "")
	    fileName += ".wrl";
	else
	    fileName = fileName.left(index) + ".wrl";
    }
    if (radioSvg->isChecked())
    {
	// No suffix: add it
	if (fileSuffix == "")
	    fileName += ".svg";
	else
	    fileName = fileName.left(index) + ".svg";
    }
    if (radioFlash->isChecked())
    {
	// No suffix: add it
	if (fileSuffix == "")
	    fileName += ".swf";
	else
	    fileName = fileName.left(index) + ".swf";
    }
    int start, len = 3;
    // Set the selection on file name: get the starting index
    if (radioSuffix->isChecked())
    {
	// No suffix: select the entire file name
	if (fileSuffix == "")
	{
	    start = 0;
	    len = fileName.length();
	}
	else
	{
	    start = index + 1;
	    len = fileName.length() - index - 1;
	}
    }
    else
    {
	// If a format is selected, select select the file name without the suffix
	start = 0;
	len = index;
    }
    // Set text, selection and focus
    textName->setText(fileName);
    textName->setSelection(start, len);
    setFocusProxy(textName);    
}
