#ifndef XPLODELISTENER_H
#define XPLODELISTENER_H

// Qt includes
#include <qpalette.h>
#include <qstring.h>
#include <qprogressdialog.h>
#include <qtimer.h>
#include <qprocess.h>
#include <qmsgbox.h>
#include <qfiledialog.h>
#include <qtextedit.h>

// This class provides the listener, a connection with the MzPlasm server
class XplodeListener : public QTextEdit
{
	Q_OBJECT

public:
	XplodeListener(QWidget *parent = 0);
	~XplodeListener();

	void updateFont();

	void openConnection();
	void reconnect();
	void closeConnection();

	void eval(QString code);
	bool isConnected();
private:
	QProcess *mzplasm;

	bool connected;
public slots:
	void receive();
signals:
	void stopEvaluation();
	void exported(QString);
};

#endif
